"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = __importDefault(require("."));
if (typeof globalThis.Blob === 'undefined') {
    // @ts-ignore - Blob simple polyfill for Node.js (only the required things are defined)
    globalThis.Blob = class SimpleBlob {
        constructor(parts) {
            this.content = parts.join("");
        }
        get size() {
            return this.content.length;
        }
        text() {
            return __awaiter(this, void 0, void 0, function* () {
                return this.content;
            });
        }
        slice(start, end) {
            return new SimpleBlob([this.content.slice(start, end)]);
        }
    };
}
const TESTS = [
    {
        lines: [
            'Hello',
            'This is my world, what did you except ?',
            'hi',
            'hel',
            'llo',
            'World !',
        ],
        sep: '\n\r\t',
        chunk: 6,
    },
    {
        lines: [],
        sep: '\n',
    },
    {
        lines: [
            'dzqoihfioeihfoishfis',
            'fseiohfiesiodneiogejpos',
            'fe,oifes,',
            'oifen',
            'kofiej',
            'f',
            '',
            '',
            'deqofnoiesnf',
        ],
        sep: 'nrttta',
        chunk: 10,
    }
];
(() => __awaiter(void 0, void 0, void 0, function* () {
    var e_1, _a;
    let test_no = 1;
    for (const test of TESTS) {
        const str = test.lines.join(test.sep);
        const file = new Blob([str]);
        const reader = new _1.default(file);
        let i = 0;
        let success = true;
        try {
            for (var _b = __asyncValues(reader.iterate(test.sep, test.chunk)), _c; _c = yield _b.next(), !_c.done;) {
                const line = _c.value;
                if (line !== test.lines[i]) {
                    success = false;
                }
                // console.log(i, line, line === test.lines[i]);
                i++;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) yield _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (!success)
            console.log(`Test n°${test_no} failed:`, test);
        else
            console.log(`Test n°${test_no} passed.`);
        test_no++;
    }
}))();
